#include <dos.h>
#include <alloc.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>


#define TRUE 0
#define FALSE -1

#define PITFREQ 1193181l
#define INTR 8

unsigned long int TIMERCycle;

unsigned int TIMERCounter;

void interrupt (* BIOSTimerHandler)();

static int grmode=FALSE;
static int old_mode=0x03;

/* image de la K7 en memoire */
#define MAXK7 65536
unsigned int K7bit;
unsigned int K7word;
unsigned int far * K7buffer;
unsigned int far * K7p;
unsigned long int K7count;

/* etat des bits */
int pre,cur;
/* compteur du decodeur */
int etat;

/* compteur de position de la visu */
int x;

FILE * fic;

void rgb(int index,int red,int green,int blue)

{
    union REGS r;
    r.h.ah=0x10;
    r.h.al=0x10;
    r.x.bx=index;
    r.h.ch=green;
    r.h.cl=blue;
    r.h.dh=red;

    int86(0x10,&r,&r);

}

void return_text(void)
{
  if (grmode==TRUE)
  {
    union REGS r;
    r.h.ah=0x00;
    r.h.al=old_mode;
    int86(0x10,&r,&r);
    grmode=FALSE;
  }
}

void graphmode(void)
{
  if (grmode==FALSE)
  {
    union REGS r;
    r.h.ah=0x0F;
    int86(0x10,&r,&r);           /* sauvegarde mode precedant */
    old_mode=r.h.al;
    r.h.ah=0x00;
    r.h.al=0x13;
    int86(0x10,&r,&r);           /* MODE graphique 13h */
    grmode=TRUE;
    r.h.ah=0x12;
    r.h.al=0x00;
    r.h.bl=0x32;
    int86(0x10,&r,&r);           /* Direct access on   */
  }
}

void TIMER_Set(int Frequency,void interrupt (*Handler)())
{
	TIMERCycle=0;

	TIMERCounter=(int)(PITFREQ/Frequency);

	BIOSTimerHandler=getvect(INTR);

	setvect(INTR,Handler);

	outp(0x43,0x34);
	outp(0x40,TIMERCounter % 256);
	outp(0x40,(int)TIMERCounter / 256);

}

void TIMER_CleanUp(void)
{
  outp(0x43,0x34);
  outp(0x40,0x0);
  outp(0x40,0x0);

  setvect(INTR,BIOSTimerHandler);
}

void interrupt TIMER_Handler(void)
{
  TIMERCycle+=TIMERCounter;

  if (TIMERCycle>=0x10000)
  {
    TIMERCycle-=0x10000;
    BIOSTimerHandler();
  }
  else
    outp(0x20,0x20);
}

void interrupt echant(void)
{
  int c;
  char far * p;
  c=inportb(0x3fe)&0x20;
  /* graphic output */
  p=MK_FP(0xA000,x+640);x++;if (x==320) x=0;
  if (c==0x20) { *p=1;p+=3200;*p=0;cur=1;}
  else         { *p=0;p+=3200;*p=1;cur=0;}
  /* decodage FM */
  /* attendre le chgt */
  if ((etat==0) && (pre!=cur))
  {
    etat=1;
    pre=cur;
  }
  else
  /* attendre 11cycles */
  if ((etat>0) && (etat<11)) etat++;
  else
  /* dcodage */
  if (etat==11)
  {
    etat=0;
    if (cur!=pre)
    /* cas 1 */
    {
      K7word|=K7bit;
    }
    pre=cur;
    K7bit=K7bit>>1;
    if ((K7bit==0) && (K7count<MAXK7))
    {
      *K7p++=K7word;
      K7bit=0x8000;
      K7word=0;
      K7count++;
    }
  }

  TIMER_Handler();
}

void main(int argc,char * argv[])
{
  long int i;

  K7bit=0x8000;
  K7word=0x0000;
  K7buffer=(int far *)farmalloc(MAXK7*2+2);
  if (K7buffer==NULL) exit(-1);
  K7p=K7buffer;
  K7count=0;

  graphmode();
  rgb(0,0,0,0);
  rgb(1,0x3f,0x3f,0x3f);
  /* le bit precedent est  0 */
  pre=0;
  etat=0;

  TIMER_Set(19200,echant);

  do
  {
  } while (!kbhit());

  getch();

  TIMER_CleanUp();

  /* fetch du dernier word */
  *K7p++=K7word;
  K7count++;

  return_text();

  fic=fopen("MO5.K7","wb");

  K7p=K7buffer;
  for (i=0;i<K7count;i++)
  {
    K7word=*K7p++;
    fputc(K7word>>8,fic);
    fputc(K7word&0xFF,fic);
  }
  fclose(fic);
  farfree(K7buffer);
}
